
import java.io.IOException;
import java.io.PrintWriter;
import html.HtmlWriter;
import html.Parser;
import html.Parser.IntParametr;
import java.util.Arrays;

import javax.servlet.ServletException;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class TvarGrafuServlet extends HttpServlet {

    public static final String sessionPrefix = "TvarGrafuServlet.";

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        HttpSession session = request.getSession();
        String[] values = new String[3];
        Integer i;
        i = (Integer) session.getAttribute(sessionPrefix + "pocet");
        if(i != null)
            values[0] = i.toString();
        i = (Integer) session.getAttribute(sessionPrefix + "width");
        if(i != null)
            values[1] = i.toString();
        i = (Integer) session.getAttribute(sessionPrefix + "height");
        if(i != null)
            values[2] = i.toString();

        response.setCharacterEncoding("utf-8");
        PrintWriter out = response.getWriter();
        printPage(out, values, new String[3]);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        String[] values = new String[3];
        String[] errors = new String[3];

        IntParametr pocet = Parser.getIntParametr(request, "pocet", 1);
        values[0] = pocet.parametr;
        if (pocet.error == 0) {
            session.setAttribute(sessionPrefix + "pocet", pocet.number);
        } else {
            switch (pocet.error) {
                case 1:
                    errors[0] = "Zadejte číslo!";
                    break;
                case 2:
                    errors[0] = "Hodnota není platné číslo!";
                    break;
                case 3:
                    errors[0] = "Zadejte číslo &gt;= 1!";
                    break;
            }
        }

        IntParametr width = Parser.getIntParametr(request, "width", 100);
        values[1] = width.parametr;
        if (width.error == 0) {
            session.setAttribute(sessionPrefix + "width", width.number);
        } else {
            switch (width.error) {
                case 1:
                    errors[1] = "Zadejte šířku!";
                    break;
                case 2:
                    errors[1] = "Zadaná šířka není platné číslo!";
                    break;
                case 3:
                    errors[1] = "Zadejte číslo &gt;= 100!";
                    break;
            }
        }

        IntParametr height = Parser.getIntParametr(request, "height", 100);
        values[2] = height.parametr;
        if (height.error == 0) {
            session.setAttribute(sessionPrefix + "height", height.number);
        } else {
            switch (height.error) {
                case 1:
                    errors[2] = "Zadejte výšku!";
                    break;
                case 2:
                    errors[2] = "Zadaná výška není platné číslo!";
                    break;
                case 3:
                    errors[2] = "Zadejte číslo &gt;= 100!";
                    break;
            }
        }
        for(int i = 0; i < errors.length; i++) {
            if(errors[i] != null) {
               response.setCharacterEncoding("utf-8");
                PrintWriter out = response.getWriter();
                printPage(out, values, errors);
                return;
            }
        }
         PrintWriter out = response.getWriter();
       // out.println(String.format("%d %d",pocet.error,pocet.number));
       response.sendRedirect(response.encodeRedirectURL("seznam-cisel"));
    }

    private void printPage(PrintWriter out, String[] values, String[] errors) {
        HtmlWriter.printHeader(out, "Koláčový graf");
        out.println("<h2>Krok 1</h2>");
        out.println("<p>Zadejte prosím počet hodnot grafu a rozměry výsledného obráku.</p>");


        out.println("<form method=\"post\" action=\".\"><fieldset>");
        out.println("<table border=\"0\">");
        HtmlWriter.printInputTableRow(out, "Počet hodnot:", "pocet", values[0], errors[0]);
        HtmlWriter.printInputTableRow(out, "Šířka obrázku:", "width", values[1], errors[1]);
        HtmlWriter.printInputTableRow(out, "Výška obrázku:", "height", values[2], errors[2]);
        out.println("</table>");
        out.println("<input type=\"submit\" name=\"submit\" /></fieldset></form>");
        HtmlWriter.printFooter(out);
    }
}
